<?php
/**
 * Elgg ShareMaps plugin
 * @package sharemaps
 */

elgg_load_library('elgg:sharemaps');

$owner = elgg_get_page_owner_entity();
if (!$owner) {
	forward('sharemaps/all');
}

elgg_push_breadcrumb(elgg_echo('sharemaps'), "sharemaps/all");
elgg_push_breadcrumb($owner->name, "sharemaps/owner/$owner->username");
elgg_push_breadcrumb(elgg_echo('friends'));

// insert google map button
if (sharemaps_allow_gmaps_link()) { 
	elgg_register_title_button('sharemaps','addembed');
}
// draw map button
elgg_register_title_button('sharemaps','drawmap/add');
// upload button
elgg_register_title_button();

$title = elgg_echo("sharemaps:friends");

$content = elgg_list_entities_from_relationship(array(
	'type' => 'object',
	'subtype' => array('sharemaps', 'drawmap'),
	'full_view' => false,
	'limit' => 10,
	'relationship' => 'friend',
	'relationship_guid' => $owner->guid,
	'relationship_join_on' => 'container_guid',
));

if (!$content) {
	$content = elgg_echo("sharemaps:none");
}

$sidebar = sharemaps_get_type_cloud($owner->guid, true);

$body = elgg_view_layout('content', array(
	'filter_context' => 'friends',
	'content' => $content,
	'title' => $title,
	'sidebar' => $sidebar,
));

echo elgg_view_page($title, $body);
